#ifndef PEBBLISP_HASH_H
#define PEBBLISP_HASH_H

#include "object.h"

struct ObjectTable {
    size_t count;
    size_t capacity;
    struct EnvElement* elements;
};

struct ObjectTable buildTable(size_t capacity);

/// Returns the hash of the inserted object
size_t addToTable(struct ObjectTable* table, char* name, Object object);

struct StrippedObject* getWithHash(struct ObjectTable* table, size_t hash);

struct StrippedObject* getFromTable(struct ObjectTable* table, const char* name);

void deleteTable(struct ObjectTable* table);

#ifdef STANDALONE

struct ObjectTableObject {
    struct ObjectTable table;
    int refs;
};

fn(buildHashTable, "table",
   "Create a hash table object."
);

fn(addToHashTable, "h-insert",
   "Insert into a hash table object."
);

fn(getFromHashTable, "h-get",
   "Get a value from a hash table object."
);

#endif

#endif //PEBBLISP_HASH_H
